#!/bin/bash
set -ex

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

DATADIR={{ noaa_gfs_datadir | quote }}
WORKDIR={{ noaa_gfs_workdir | quote }}
mkdir -p "$WORKDIR" "$DATADIR"

HERE="`dirname $0`"
FETCHGFS="$HERE/fetchGFS_0p25.py"
CONFIGGFS="$HERE/cdmGribReaderConfigGFS.xml"

FIMEX_VCROSS={{ metws_job_scripts | quote }}/util/fimex-vcross
FIMEX_VERIF={{ metws_job_scripts | quote }}/util/fimex-verif
RT={{ metws_job_scripts | quote }}/util/rounded_times

# cleanup
AGE={{ noaa_gfs_max_age_days | quote }}
find "$WORKDIR" -maxdepth 1 -type d -name 'gfs_0p25_????????_??' -mtime "+$AGE" -exec rm -rf \{\} \;
find "$WORKDIR" -type f -name 'gfs_0p25_????????_??.grbml'       -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name 'gfs_0p25_????????_??.nc'          -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name 'gfs_0p25_????????_??_vc.nc'       -mtime "+$AGE" -exec rm -vf \{\} \;
find "$DATADIR" -type f -name 'gfs_0p25_????????_??_vf.nc'       -mtime "+$AGE" -exec rm -vf \{\} \;

# fetch grib files and create grbml index file
INT={{ noaa_gfs_reftime_interval | quote }}
DLY={{ noaa_gfs_reftime_delay | quote }}
CNT={{ noaa_gfs_reftime_count | quote }}
for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
    if "$FETCHGFS" \
           --retrievals "$HERE/gfs_retrievals.ini" \
           --workdir "$WORKDIR" \
           --grib-cdm-config "$CONFIGGFS" \
           --minlon {{ noaa_gfs_gefs_minlon }} \
           --maxlon {{ noaa_gfs_gefs_maxlon }} \
           --minlat {{ noaa_gfs_gefs_minlat }} \
           --maxlat {{ noaa_gfs_gefs_maxlat }} \
           "$TIME"
    then
        :
    else
        T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
        rm -vf "$WORKDIR/gfs_0p25_${T}.grbml"
        rm -rf "$WORKDIR/gfs_0p25_${T}"
    fi
done

# create netCDF-files
for i in "$WORKDIR"/gfs_0p25_????????_??.grbml; do
    NCFILE="${i/.grbml/.nc}"
    NCFILE="${DATADIR}/`basename $NCFILE`"
    if test ! -f "$NCFILE" -o "$CONFIGGFS" -nt "$NCFILE" -o "$i" -nt "$NCFILE" ; then
        echo "creating $NCFILE"
        rm -vf "$NCFILE" "${NCFILE/.nc/_vc.nc}"
        fimex \
            --input.file="$i" \
            --input.type=grbml \
            --input.config="$CONFIGGFS" \
            --output.file="$NCFILE" \
            --output.type=nc4
    else
        echo "$NCFILE exists, not creating new one"
    fi

    "$FIMEX_VCROSS" "$NCFILE"
    "$FIMEX_VERIF"  "$NCFILE"
done

MP={{ metws_job_scripts | quote }}/util/make_time_size_prom_file
if test -x "$MP" ; then
    FILES=()
    VCFILES=()
    for TIME in `"$RT" --interval "$INT" --delay "$DLY" --count "$CNT"` ; do
        T=`date --utc '+%Y%m%d_%H' --date "$TIME"`
        FILES+=("${DATADIR}/gfs_0p25_${T}.nc")
        VCFILES+=("${DATADIR}/gfs_0p25_${T}_vc.nc")
    done

    "$MP" devcoop_noaa_gfs_0p25_latest "latest GFS 0p25 NetCDF file" "${FILES[@]}"
    "$MP" devcoop_noaa_gfs_0p25_vc_latest "latest GFS 0p25 vcross NetCDF file" "${VCFILES[@]}"
fi

exit 0
